VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "EnvGrid"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Experimental Environment Grid
' the idea is quite obvious: using a grid to store
' environment features (such as friction, swimming factor,
' brownian motion, energy token for vegs, wall, etc).
' Then one can draw, save and reload environment maps
' with features distributed unequally, niches, etc.
' My first idea (coming also from the discussions on the message board)
' was of giving the user the ability to define "materials"
' groups of features with a label name, and spreading them
' in the grid

' You can see the very first embryo of it in this way:
' start a simulation, then pause the visual basic program,
' go to the immediate pane and invoke initenv (simply write
' initenv) and restart the program


Dim grid(100, 100) As Byte

Private Type material
  Name As String
  colour As Long
  dat(10) As Single
End Type

Dim matlist(255) As material

Private Sub Class_Initialize()
  matlist(1).Name = "*end*"
  For xx = 0 To 100
    For yy = 0 To 100
      grid(xx, yy) = 0
    Next yy
  Next xx
End Sub

Sub CreateMaterial(Name As String, col As Long, dat() As Single)
  Dim t As Integer
  t = 1
  While matlist(t).Name <> "*end*" And matlist(t).Name <> Name
    t = t + 1
  Wend
  If matlist(t).Name = "*end*" Then
    matlist(t).Name = Name
    matlist(t + 1).Name = "*end*"
  End If
  matlist(t).colour = col
  For k = 0 To 10
    matlist(t).dat(k) = dat(k)
  Next k
End Sub

Private Function matnum(Name As String) As Integer
  Dim t As Integer
  t = 0
  While matlist(t).Name <> "*end*" And matlist(t).Name <> Name
    t = t + 1
  Wend
  If matlist(t).Name = "*end*" Then
    t = -1
  End If
  matnum = t
End Function

Sub TraceSquare(matname As String, x1 As Integer, y1 As Integer, x2 As Integer, y2 As Integer)
  Dim num As Integer
  Dim xx As Integer, yy As Integer
  num = matnum(matname)
  If num > 0 Then
    For xx = x1 To x2
      For yy = y1 To y2
        grid(xx, yy) = num
      Next yy
    Next xx
  End If
End Sub

Sub SetMainMat(dat() As Single)
  For t = 0 To 10
    matlist(0).dat(t) = dat(t)
  Next t
End Sub

Sub DrawGrid(pic As PictureBox)
  Dim xx As Integer, yy As Integer
  For xx = 0 To 99
    For yy = 0 To 99
      pic.Line (xx * (pic.ScaleWidth / 99), yy * (pic.ScaleHeight / 99))-Step(pic.ScaleWidth / 99, pic.ScaleHeight / 99), matlist(grid(xx, yy)).colour
    Next yy
  Next xx
End Sub


Public Property Get GetMat(x As Byte, Y As Byte) As Variant
  GetMat = matlist(grid(x, Y)).dat
End Property


